AWL(1)

# NAME
awl - drill, writ small

# SYNOPSIS
*awl* [ _OPTIONS_ ] _name_ [ _@server_ ] [ _type_ ]++
where

_name_ is the query to make (*example: froth.zone*)++
_@server_ is the server to query (*example: dns.froth.zone*)++
_type_ is the DNS resource type (*example: AAAA*)

# DESCRIPTION

*awl*  (*a*wls *w*ant *l*icorice) is a simple tool designed to make DNS queries, much like the venerable _dig_(1).
An awl is a tool used to make small holes, typically used in tannery (leatherworking).

Written in Go, *awl* is designed to be a more "modern" version of _drill_(1) by including some more RFCs and output options.
*awl* is still heavily Work-In-Progress so some features may get added or removed.

# OPTIONS
	_Dig-like queries are supported, see dig(1)_

	*-D*, *--dnssec*++
	Enable DNSSEC. This needs to be manually enabled.

	*--debug*++
	Enable debug logging (currently WIP).

	*-v*++
	Print the version and exit.

	*-h*++
	Show a "short" help message.

## Query Options
	*-4*++
	Only make query over IPv4

	*-6*++
	Only make query over IPv6

	*-p*, *--port* _port_++
	Sets the port to query.++
	++
_Default Ports_:
		- _53_ for *UDP* and *TCP*
		- _853_ for *TLS* and *QUIC*
		- _443_ for *HTTPS*

	*--no-truncate*++
	Ignore UDP truncation (by default, awl _retries with TCP_)

	*-t*, *--tcp*++
	Use TCP for the query (see _RFC 7766_)

	*-u*, *--udp*++
	Use UDP for the query (default)

	*-T*, *--tls*++
	Use DNS-over-TLS, implies *-t* (see _RFC 7858_)

	*-H*. *--https*++
	Use DNS-over-HTTPS (see _RFC 8484_)

	*-Q*. *--quic*++
	Use DNS-over-QUIC (see _RFC 9250_)

	*-x*, *--reverse*++
	Do a reverse lookup. Sets default _type_ to PTR.++
	*awl* automatically makes an IP or phone number canonical.

## DNS Flags

	*--aa*++
	_SET_ Authoritative Answer (default: unset)

	*--ad*++
	_SET_ Authenticated Data (default: unset)

	*--tc*++
	_SET_ TC (TrunCated) flag (default: not set)

	*-z*++
	_SET_ Z (Zero) flag (default: not set)

	*--cd*++
	_SET_ CD (Checking Disabled) flag (default: not set)

	*--no-qr*++
	_UNSET_ QR (QueRy) flag (default: set)

	*--no-rd*++
	_UNSET_ RD (Recursion Desired) flag (default: set)

	*--no-ra*++
	_UNSET_ RA (Recursion Available) flag (default: set)

## Output Options
	*-j*, *--json*++
	Print the query results as JSON.

	*-X*, *--xml*++
	Print the query results as XML.

	*-y*, *--yaml*++
	Print the query results as YAML.

	*-s*, *--short*++
	Print just the results.++
	Equivalent to *dig +short*

# SEE ALSO
_drill_(1), _dig_(1), the many DNS RFCs